#ifndef CPKEYBOARDMANAGER_INCLUDED
#define CPKEYBOARDMANAGER_INCLUDED

#include "peg.hpp"

enum KeyboardTab {
   KEYBOARD_MA = 0,
   KEYBOARD_ABC,
   KEYBOARD_CAT,
   KEYBOARD_2D,
};

class CPKeyboardManager : public PegNotebook
{
protected:
    PegRect GetMyRectFromAppRect(PegRect rect);
    void ForwardMessageToCurrentThing(PegMessage &Mesg);
    
public:
    CPKeyboardManager(const PegRect &Rect);
    virtual ~CPKeyboardManager();
    void Draw(void);
    
    void AddEditButtons();
    
    void SetKeyboard(UCHAR uTab)
    {
        SelectTab(uTab);
    }
    UCHAR GetKeyboard()
    {
        return GetCurrentPage();
    }
};

class CPKeypad: public CPKeyboardManager
{
public:
    CPKeypad(const PegRect &Rect);
};

#endif

