#ifndef EDITWINDOW_INCLUDED
#define EDITWINDOW_INCLUDED

#include "ClassPad.h"
#include "FaTextBox.h"
#include "FaKeypad.h"

class EditWindow: public CPModuleWindow
{
protected:
    CPMultiButton *evState;
    FaTextBox *ed;
    PegTextBox *vw;
    
    bool Saved;
    
    int PageNum;
    int PageCount;
    
    PEGCHAR *sText;
    
    #ifdef WIN32
        FaKeypad *fKeypad;
        bool vState;
    #endif
    
public:
    EditWindow(PegRect rect, CPMainFrame* frame) : CPModuleWindow(rect, 0, 0, frame)
    {
        Init();
    }
	~EditWindow(){}
    
    void Draw();
    void AddUI();
    PegMenuDescriptionML* GetMenuDescriptionML();
    void Init();
    void SetCorrectStat();
    SIGNED Message(const PegMessage &Mesg);
    
    //Dialogs/Messages
    bool Dlg();
    void Dlg(bool dState);
    WORD MsgBox(PEGCHAR *title, PEGCHAR *text, bool haveCancel = true);
    
    //Files
    void New();
    void Open();
    void RealOpen();
    bool IsModified();
    WORD SaveDlg(PEGCHAR *Title = "Farsi Negar");
    bool Save(int mode = 1);
    bool SaveAs(int mode = 1);
    
    //Data and Files
    void WriteData(CPWriteFile &f, int mode);
    CPString ReadData(CPReadFile &r);
    
    //Pages
    void InsPage();
    void DelPage();
    void PrevPage();
    void NextPage();
    void Goto();
    
    //Other
    void Read();
    void Edit();
    #ifdef WIN32
        void SetFKeypad(bool kState);
    #endif
};

#endif

