#include "FNFrame.h"
#include "Farsi.h"
#include "FaNegar.h"

PegMenuDescriptionML FNOPMenu[] = {
	{ NULL, CMN_MENU_OP_CLOSE, FWM_CLOSE, AF_ENABLED, NULL },
    DECLARE_MENU_LINE
    { NULL, SYSTEM_VERSION, ID_ABOUT, AF_ENABLED, NULL },
    #ifndef WIN32
    { NULL, CMN_APP_RUN, ID_DISP_MAIN, AF_ENABLED, NULL },
	#endif
    DECLARE_MENU_LINE
	{ NULL, SYS_CMN_KEY, FWM_KEYPAD, AF_ENABLED, NULL },
	DECLARE_MENU_LINE
	DECLARE_MENU_SETTINGS
	{ NULL, CMN_NO_ID, 0, 0, NULL }
};
PegMenuDescriptionML FNFrameMenu[] = {
	{ NULL, CMN_MENU_OP, IDB_SETTINGS_MENU, AF_ENABLED, FNOPMenu },
	{ NULL, CMN_NO_ID, 0, 0, NULL }
};

FNFrame::FNFrame(PegRect &Rect) : CPMainFrame(Rect)
{
    DialogRunning = false;
}

PegMenuDescriptionML* FNFrame::GetMenuDescriptionML()
{
	return FNFrameMenu;
}
#ifndef WIN32
/** Unsupported, shows ClassPad's Main application. */
CPModuleWindow *ReplaceModuleWindow(SIGNED iNewWindowID, void *pVoid = 0, BOOL bActive = TRUE);
void FNFrame::ShowMain()
{
    #define IDB_MODULE_MAIN_WINDOW TYPE_MOD_RUNCAS
    ReplaceModuleWindow(IDB_MODULE_MAIN_WINDOW);
    MainWindow()->Message(FWM_KEYPAD_WAS_TOGGLED);
}
#endif

/** Shows the Version dialog box. */
void FNFrame::ShowVer()
{
    if (DialogRunning) return;
    
    WORD FNChars[] = {feh_, _alef, reh, sin_, _yeh, vspace, noon_, _gaf_, _alef, reh,
    space, '*', '*', '*', space,
    noon_, _sin_, _kheh_, _heh, digit2, vspace, slash, vspace, digit1 };
    CPString FN;
    int size = sizeof(FNChars) / sizeof(WORD);
    for (int i = 0; i < size; i++)
        FN += FNChars[size - i - 1];
    
    extern PegFont FaClassPad;
    CPString AboutText(FN);
    AboutText += "\nThanksTo: Brian Maguire,\nKilburn, Orwell\nwww.CasioCalc.org";
    
    CPDialog *verWin = new CPDialog(CP_DIALOG_SIZE_QUARTER, CP_DIALOG_POS_CENTER, "Farsi Negar");
    
    PegRect r = {0, 79, 160, 240};
    PegTextBox *p = new PegTextBox(r, 0, EF_WRAP|TJ_CENTER|TT_COPY, AboutText.GetBuffer());
    p->SetFont(&FaClassPad);
    verWin->Add(p);
    
    DialogRunning = true;
    verWin->Execute();
    DialogRunning = false;
}

SIGNED FNFrame::Message(const PegMessage &Mesg)
{
	switch(Mesg.wType)
    {
        #ifndef WIN32
		case SIGNAL(ID_DISP_MAIN, PSF_CLICKED): ShowMain(); break;
	    #endif
  		case SIGNAL(ID_ABOUT, PSF_CLICKED):     ShowVer();  break;
		default:
	        return CPMainFrame::Message(Mesg);
    }
    return 0;
}

