#ifndef FACHAR_INCLUDED
#define FACHAR_INCLUDED

#include "ClassPad.h"

/** Provides a class that parses multi-byte chars to make them easier to use. */
class FaChar
{
public:
    WORD c1;
    WORD c2;
    
    FaChar()
    {
        c1 = 0x00;
        c2 = 0x00;
    }
    FaChar(WORD bytes)
    {
        c1 = (bytes & 0xFF00) / 0x100;
        c2 = (bytes & 0x00FF);
        if (c1 == 0x00)
        {
            c1 = c2;
            c2 = 0x00;
        }
    }
    ~FaChar(){}
    
    void Set(WORD byte1, WORD byte2)
    {
        c1 = byte1;
        c2 = byte2;
    }
    
    WORD FullChar()
    {
        switch (c1)
        {
            case 0xEC:
                return (0xEC00 + c2);
            case 0xED:
                return (0xED00 + c2);
            case 0xEE:
                return (0xEE00 + c2);
        }
        return c1;
    }
};

#ifdef WIN32
/** A simple class that is mainly used to convert a char to a FaChar. RawFaChar's
constructor does not parse the char. */
class RawFaChar : public FaChar
{
public:
    RawFaChar(WORD byte1)
    {
        c1 = byte1;
        c2 = 0x00;
    }
    ~RawFaChar(){}
    
    WORD FullChar()
    {
        return c1;
    }
};
#endif

#endif

