#include "FaKeypad.h"
#include "Farsi.h"
#include "FaNegar.h"

extern PegFont FaClassPad;
extern PegBitmap gbDottedBitmap;
extern PegBitmap gbShiftBtnBitmap;
PegTextButton* b;
CPToggleButton *ShiftBtn;

void FaKeypad::Draw()
{
    BeginDraw();
	Invalidate(mReal); 
	DrawFrame();
	PegRect gRect = {mReal.wLeft+1, mReal.wTop+16, mReal.wRight-1, mReal.wTop+48};
	BitmapFill(gRect, &gbDottedBitmap);
	PegRect sRect = ShiftBtn->mReal;
	PegColor black;
	Line(sRect.wLeft+1, sRect.wBottom+1, sRect.wRight, sRect.wBottom+1, black);
	DrawChildren();
    EndDraw();    
}

SIGNED FaKeypad::Message(const PegMessage &Mesg)
{
	switch(Mesg.wType)
    {
        case SIGNAL(Kpeh, PSF_CLICKED):    SendKeyMsg(shift ? multis : peh);    break;
        case SIGNAL(Kdigit1, PSF_CLICKED): SendKeyMsg(shift ? excal : digit1);  break;
        case SIGNAL(Kdigit2, PSF_CLICKED): SendKeyMsg(shift ? equals : digit2); break;
        case SIGNAL(Kdigit3, PSF_CLICKED): SendKeyMsg(shift ? minus : digit3);  break;
        case SIGNAL(Kdigit4, PSF_CLICKED): SendKeyMsg(shift ? plus : digit4);   break;
        case SIGNAL(Kdigit5, PSF_CLICKED): SendKeyMsg(shift ? pcs : digit5);    break;
        case SIGNAL(Kdigit6, PSF_CLICKED): SendKeyMsg(shift ? caret : digit6);  break;
        case SIGNAL(Kdigit7, PSF_CLICKED): SendKeyMsg(shift ? divs : digit7);   break;
        case SIGNAL(Kdigit8, PSF_CLICKED): SendKeyMsg(shift ? star : digit8);   break;
        case SIGNAL(Kdigit9, PSF_CLICKED): SendKeyMsg(shift ? cparen : digit9); break;
        case SIGNAL(Kdigit0, PSF_CLICKED): SendKeyMsg(shift ? oparen : digit0); break;
        case SIGNAL(Kback, PSF_CLICKED):   SendKeyMsg(8);                       break;
        
        case SIGNAL(Kzad, PSF_CLICKED):    SendKeyMsg(shift ? vari : zad);      break;
        case SIGNAL(Ksad, PSF_CLICKED):    SendKeyMsg(shift ? varj : sad);      break;
        case SIGNAL(Kceh, PSF_CLICKED):    SendKeyMsg(shift ? vark : ceh);      break;
        case SIGNAL(Kghaf, PSF_CLICKED):   SendKeyMsg(shift ? eulers : ghaf);   break;
        case SIGNAL(Kfeh, PSF_CLICKED):    SendKeyMsg(shift ? pins : feh);      break;
        case SIGNAL(Kghein, PSF_CLICKED):  SendKeyMsg(shift ? infs : ghein);    break;
        case SIGNAL(Kein, PSF_CLICKED):    SendKeyMsg(shift ? aps : ein);       break;
        case SIGNAL(Kheh, PSF_CLICKED):    SendKeyMsg(shift ? lcomma : heh);    break;
        case SIGNAL(Kkheh, PSF_CLICKED):   SendKeyMsg(shift ? csbrac : kheh);   break;
        case SIGNAL(Kha, PSF_CLICKED):     SendKeyMsg(shift ? osbrac : ha);     break;
        case SIGNAL(Kjim, PSF_CLICKED):    SendKeyMsg(shift ? ccbrac : jim);    break;
        case SIGNAL(Kcheh, PSF_CLICKED):   SendKeyMsg(shift ? ocbrac : cheh);   break;
        
        case SIGNAL(Kshin, PSF_CLICKED):   SendKeyMsg(shift ? hheh : shin);     break;
        case SIGNAL(Ksin, PSF_CLICKED):    SendKeyMsg(shift ? dheh : __sin);    break;
        case SIGNAL(Kyeh, PSF_CLICKED):    SendKeyMsg(shift ? yehd : yeh);      break;
        case SIGNAL(Kbeh, PSF_CLICKED):    SendKeyMsg(shift ? akaf : beh);      break;
        case SIGNAL(Klam, PSF_CLICKED):    SendKeyMsg(shift ? talef : lam);     break;
        case SIGNAL(Kalef, PSF_CLICKED):   SendKeyMsg(shift ? aa : alef);       break;
        case SIGNAL(Kteh, PSF_CLICKED):    SendKeyMsg(shift ? tatweel : teh);   break;
        case SIGNAL(Knoon, PSF_CLICKED):   SendKeyMsg(shift ? cquote : noon);   break;
        case SIGNAL(Kmim, PSF_CLICKED):    SendKeyMsg(shift ? oquote : mim);    break;
        case SIGNAL(Kkaf, PSF_CLICKED):    SendKeyMsg(shift ? colon : kaf);     break;
        case SIGNAL(Kgaf, PSF_CLICKED):    SendKeyMsg(shift ? scolon : gaf);    break;
        
        case SIGNAL(Kshift, PSF_CHECK_ON): shift = true;  SetTexts();           break;
        case SIGNAL(Kshift, PSF_CHECK_OFF):shift = false; SetTexts();           break;
        case SIGNAL(Kza, PSF_CLICKED):     SendKeyMsg(shift ? varx : za);       break;
        case SIGNAL(Kta, PSF_CLICKED):     SendKeyMsg(shift ? vary : ta);       break;
        case SIGNAL(Kzeh, PSF_CLICKED):    SendKeyMsg(shift ? varz : zeh);      break;
        case SIGNAL(Kreh, PSF_CLICKED):    SendKeyMsg(shift ? hvav : reh);      break;
        case SIGNAL(Kzal, PSF_CLICKED):    SendKeyMsg(shift ? halef : zal);     break;
        case SIGNAL(Kdal, PSF_CLICKED):    SendKeyMsg(shift ? alefh : dal);     break;
        case SIGNAL(Khyeh, PSF_CLICKED):   SendKeyMsg(shift ? hamza : hyeh);    break;
        case SIGNAL(Kvav, PSF_CLICKED):    SendKeyMsg(shift ? lts : vav);       break;
        case SIGNAL(Kdot, PSF_CLICKED):    SendKeyMsg(shift ? gts : dot);       break;
        case SIGNAL(Kslash, PSF_CLICKED):  SendKeyMsg(shift ? qmark : slash);   break;
        case SIGNAL(Kjeh, PSF_CLICKED):    SendKeyMsg(shift ? comma : jeh);     break;
        
        case SIGNAL(Kstyle, PSF_CLICKED):  SendKeyMsg(shift ? vconn : 4);       break;
        case SIGNAL(Khome, PSF_CLICKED):   SendKeyMsg(PK_HOME);                 break;
        case SIGNAL(Kend, PSF_CLICKED):    SendKeyMsg(PK_END);                  break;
        case SIGNAL(Kspace, PSF_CLICKED):  SendKeyMsg(shift ? vspace : space);  break;
        case SIGNAL(Kldel, PSF_CLICKED):   SendKeyMsg(2);                       break;
        case SIGNAL(Krdel, PSF_CLICKED):   SendKeyMsg(PK_DELETE);               break;
        case SIGNAL(Kexe, PSF_CLICKED):    SendKeyMsg(shift ? 3 : CP_CHAR_CR);  break;
        
		default:
            return CPWindow::Message(Mesg);
    }
    return 0;
}

/** Sends a PM_KEY message to the current PegThing when a key is pressed. */
void FaKeypad::SendKeyMsg(WORD btn)
{
    if (shift)
    {
        shift = false;
        SetTexts();
    }
    PegMessage keyMsg(Presentation()->GetCurrentThing(), PM_KEY);
    keyMsg.iData = btn;
    MessageQueue()->Push(keyMsg);
}

/** Add buttons, but does not set their text. */
void FaKeypad::AddButtons()
{
    keyOffset = 1;
    
    //Row 1
    sv = 12;
    r.Set(1, 0, 13, 16);
    AddButton("", 11);
    
    r.wRight = 158;
    AddButton(barrow);
    
    //Row 2
    sv = 15;
    r.Set(4, 16, 19, 32);
    AddButton("", 2);
    
    sv = 13;
    r.wRight -= 2;
    AddButton();
    
    sv = 12;
    r.wRight -= 1;
    AddButton("", 9);
    
    //Row 3
    sv = 17;
    r.Set(6, 32, 23, 48);
    AddButton("", 2);
    
    sv = 14;
    r.wRight -= 3;
    AddButton();
    
    sv = 13;
    r.wRight -= 1;
    AddButton();
    
    sv = 11;
    r.wRight -= 2;
    AddButton("", 4);
    
    sv = 12;
    r.wRight += 1;
    AddButton();
    
    sv = 15;
    r.wRight += 3;
    AddButton("", 2);
    
    //Row 4
    sv = 20;
    r.Set(1, 48, 20, 63);
    ShiftBtn = new CPToggleButton(r, &gbShiftBtnBitmap, KEY_START + keyOffset++);
	AddR(ShiftBtn);
	r.Shift(sv, 0);
    
	sv = 12;
	r.wRight -= 7; //Actually -8 + 1
	r.wBottom += 1;
    AddButton("", 2);
    
    sv = 11;
	r.wRight -= 1;
    AddButton("", 2);
    
    sv = 12;
	r.wRight += 1;
    AddButton("", 2);
    
    sv = 14;
	r.wRight += 2;
    AddButton();
    
    sv = 12;
	r.wRight -= 2;
    AddButton();
    
    sv = 10;
	r.wRight -= 2;
    AddButton();
	
	sv = 12;
	r.wRight += 2;
    AddButton();
	
	r.wRight = 158;
    AddButton();
    
    //Row 5
    sv = 32;
    r.Set(4, 66, 34, 81);
    AddButton();
    
    sv = 12;
    r.wRight -= 18;
    AddButton(ahome);
    AddButton(aend);
    
    sv = 37;
    r.Set(62, 66, 97, 81);
    AddButton();
    
    sv = 12;
    r.wRight -= 23;
    AddButton(aldel);
    AddButton(ardel);
    
	r.Set(125, 66, 155, 81);
	AddButton();
}

/** Sets the text of the buttons at the start and also when the 'Shift' is set
to on/off. */
void FaKeypad::SetTexts()
{
    //Row 1
    SetText(Kpeh, shift ? multis : peh);
    SetText(Kdigit1, shift ? excal : digit1);
    SetText(Kdigit2, shift ? equals : digit2);
    SetText(Kdigit3, shift ? minus : digit3);
    SetText(Kdigit4, shift ? plus : digit4);
    SetText(Kdigit5, shift ? pcs : digit5);
    SetText(Kdigit6, shift ? caret : digit6);
    SetText(Kdigit7, shift ? divs : digit7);
    SetText(Kdigit8, shift ? star : digit8);
    SetText(Kdigit9, shift ? cparen : digit9);
    SetText(Kdigit0, shift ? oparen : digit0);
    
    //Row 2
    SetText(Kzad, shift ? vari : zad);
    SetText(Ksad, shift ? varj : sad);
    SetText(Kceh, shift ? vark : ceh);
    SetText(Kghaf, shift ? eulers : ghaf);
    SetText(Kfeh, shift ? pins : feh);
    SetText(Kghein, shift ? infs : ghein);
    SetText(Kein, shift ? aps : ein);
    SetText(Kheh, shift ? lcomma : heh);
    SetText(Kkheh, shift ? csbrac : kheh);
    SetText(Kha, shift ? osbrac : ha);
    SetText(Kjim, shift ? ccbrac : jim);
    SetText(Kcheh, shift ? ocbrac : cheh);
    
    //Row 3
    SetText(Kshin, shift ? hheh : shin);
    SetText(Ksin, shift ? dheh : __sin);
    SetText(Kyeh, shift ? yehd : yeh);
    SetText(Kbeh, shift ? akaf : beh);
    SetText(Klam, shift ? talef : lam);
    SetText(Kalef, shift ? aa : alef);
    SetText(Kteh, shift ? tatweel : teh);
    SetText(Knoon, shift ? cquote : noon);
    SetText(Kmim, shift ? oquote : mim);
    SetText(Kkaf, shift ? colon : kaf);
    SetText(Kgaf, shift ? scolon : gaf);
    
    //Row 4
    ShiftBtn->SetSelected(shift);
    SetText(Kza, shift ? varx : za);
    SetText(Kta, shift ? vary : ta);
    SetText(Kzeh, shift ? varz : zeh);
    SetText(Kreh, shift ? hvav : reh);
    SetText(Kzal, shift ? halef : zal);
    SetText(Kdal, shift ? alefh : dal);
    SetText(Khyeh, shift ? hamza : hyeh);
    SetText(Kvav, shift ? lts : vav);
	SetText(Kdot, shift ? gts : dot);
	SetText(Kslash, shift ? qmark : slash);
    SetText(Kjeh, shift ? comma : jeh);
    
    //Row 5
    CPString STYLE;
	STYLE += vspace;
    STYLE += _dal;
    STYLE += _jim_;
    STYLE += beh_;
    STYLE += alef;
    CPString VCONN;
    VCONN += vspace;
    VCONN += _dal;
    VCONN += vspace;
    VCONN += vspace;
    VCONN += vspace;
    VCONN += _jim_;
    VCONN += vspace;
    VCONN += vspace;
    VCONN += vspace;
    VCONN += beh_;
    VCONN += vspace;
    VCONN += alef;
    SetText(Kstyle, shift ? VCONN.GetBuffer() : STYLE.GetBuffer());
    
    CPString SPACE;
    SPACE += _heh;
    SPACE += _lam_;
    SPACE += sad_;
    SPACE += _alef;
    SPACE += feh_;
    CPString VSPACE;
    VSPACE += vspace;
    VSPACE += yeh;
    VSPACE += zeh;
    VSPACE += _alef;
    VSPACE += _jim_;
    VSPACE += mim_;
    SetText(Kspace, shift ? VSPACE.GetBuffer() : SPACE.GetBuffer());
    
    CPString EXE;
    EXE += vspace;
    EXE += vspace;
    EXE += "EXE";
    CPString LINE;
    LINE += vspace;
    LINE += "LINE";
    SetText(Kexe, (PEGCHAR*)(shift ? LINE.GetBuffer() : EXE.GetBuffer()));
    
    Redraw();
}

/** Adds multiple buttons with the specified text. */
void FaKeypad::AddButton(PEGCHAR *text, int count)
{
    for (int i = 1; i <= count; i++)
    {
    	b = new PegTextButton(r, text, KEY_START + keyOffset++, AF_ENABLED|TJ_CENTER|TT_COPY);
    	b->SetFont(&FaClassPad);
    	AddR(b);
    	r.Shift(sv, 0);
    }
}

/** Adds a button with a WORD as the button text. */
void FaKeypad::AddButton(WORD text)
{
    CPString str;
    str += vspace;
    str += text;
	b = new PegTextButton(r, str.Text(), KEY_START + keyOffset++, AF_ENABLED|TJ_CENTER|TT_COPY);
	b->SetFont(&FaClassPad);
	AddR(b);
	r.Shift(sv, 0);
}

/** Adds a button. */
void FaKeypad::AddButton(const PEGCHAR *text)
{
    CPString str;
    str += vspace;
    str += text;
	b = new PegTextButton(r, str.Text(), KEY_START + keyOffset++, AF_ENABLED|TJ_CENTER|TT_COPY);
	b->SetFont(&FaClassPad);
	AddR(b);
	r.Shift(sv, 0);
}

/** Sets the text of the specified button using a WORD as the text. */
void FaKeypad::SetText(WORD key, WORD text)
{
    CPString str;
    str += vspace;
    str += text;
	((PegTextButton*)Find(key))->DataSet(str.Text());
}

/** Sets the text of the specified button. */
void FaKeypad::SetText(WORD key, PEGCHAR *text)
{
    CPString str;
    str += vspace;
    str += text;
	((PegTextButton*)Find(key))->DataSet(str.Text());
}

