#ifndef FATEXTBOX_INCLUDED
#define FATEXTBOX_INCLUDED

#include "ClassPad.h"
#include "Farsi.h"

class FaTextBox: public CPEditBox
{
protected:
    bool shift;
    PegPoint urCTemp;
    PEGCHAR *urTemp;
    PegPoint urCursor;
    PEGCHAR *urText;
    
public:
    FaTextBox(PegRect rect) : CPEditBox(rect)
    {
        Init();
    }
	~FaTextBox(){}
    
    void Init();
    SIGNED Message(const PegMessage &Mesg);
    #ifdef WIN32
        //Type
        bool shspaceTOvspace;
        //Type & PC>CP conversion
        bool akafTOkaf;
        bool yehdTOyeh;
        bool ldigitTOdigit;
        bool lparenTOparen;
        //Type & conversions
        bool CNVparen;
        bool CNVsbrac;
        bool CNVcbrac;
        bool CNVquote;
        bool CNVgtlt;
        //CP>PC conversions
        bool kafTOakaf;
        bool yehTOyehd;
        
        void SendKeyMsg(WORD btn);
        void InsertCharEx(WORD chr);
        WORD ChrToPChr(WORD chr);
    #endif
    
    //Undo/Redo
    void UndoRedo();
    void ArrangeUndo();
    void RemoveUndo(PEGCHAR* prevUndo);
    
    //Cursor
    PegPoint *Cursor();
    
    //Typing/Formatting
    void StyleLetters(bool doRedraw = true, FaChar Curr = *(new FaChar));
    void Backspace();
    void NewLine();
};

#endif

