void Dummy(){}

#ifdef WIN32

#include "OptsDialog.h"
class FaMultiLineCheckBox : public CPWindow
{
protected:
    PegCheckBox *mChk;
    PegTextBox *mLbl;
    
public:
    FaMultiLineCheckBox(PegRect Rect, SIGNED LineCount, const CPString& Caption, WORD mId)
      : CPWindow(Rect, FF_NONE)
    {
        extern PegFont FaClassPad;
        
        PegRect rLbl = {mReal.wLeft, mReal.wTop,
          mReal.wRight - 9 - 20, mReal.wTop + LineCount * FaClassPad.uHeight + 3};
        mLbl = new PegTextBox(rLbl, ID_MLBL, FF_NONE|TJ_RIGHT|EF_WRAP|AF_TRANSPARENT|TT_COPY,
          Caption.GetBuffer());
        mLbl->SetFont(&FaClassPad);
        Add(mLbl);
        
        mReal.wBottom = mLbl->mReal.wBottom;
        
        PegRect rChk = {mReal.wRight - 8 - 20, mReal.wTop,
          mReal.wRight, mReal.wBottom};
        mChk = new PegCheckBox(rChk, "", mId, AF_ENABLED);
        Add(mChk);
    }
    ~FaMultiLineCheckBox(){}
    
    void SetSelected(bool sel)
    {
        mChk->SetSelected(sel);
    }
    bool IsChecked()
    {
        return mChk->IsChecked();
    }
    static SIGNED iHeight(SIGNED LineCount)
    {
        extern PegFont FaClassPad;
        return LineCount * FaClassPad.uHeight + 3;
    }
    
    SIGNED Message(const PegMessage& Mesg)
    {
        switch (Mesg.wType)
        {
            case PM_LBUTTONUP:
                if (Find(ID_MLBL)->mReal.Contains(Mesg.Point)) SetSelected(!IsChecked());
                break;
            default:
                return CPWindow::Message(Mesg);
        }
        return 0;
    }
};

void OptsDialog::Init()
{
    PegTextBox *Title;
    extern PegFont FaClassPad;
    FaMultiLineCheckBox *chk;
    CPString text;
    int size;
	int i;
    
    PegRect L1 = {0, 0, mReal.wRight, FaMultiLineCheckBox::iHeight(1)};
    PegRect L2 = {0, 0, mReal.wRight, FaMultiLineCheckBox::iHeight(2)};
    
    PegRect lRect = {mReal.wLeft, mReal.wTop+14, mReal.wRight-1, mReal.wBottom-24};
    PegVertList *list = new PegVertList(lRect);
    list->SetScrollMode(WSM_VSCROLL);
    Add(list);
    
    //When Typing
    text = "";
    WORD whenTyping[] = {teh_, _alef, yeh_, _peh, colon};
    size = sizeof(whenTyping) / sizeof(WORD);
    for (i = 0; i < size; i++) text += whenTyping[size - i - 1];
    
    Title = new PegTextBox(L1, 0, FF_NONE|TJ_RIGHT|TT_COPY, text.GetBuffer());
    Title->SetFont(&FaClassPad);
    Title->SetColor(PCI_NORMAL, BLACK);
    Title->SetColor(PCI_SELECTED, WHITE);
    Title->SetColor(PCI_NTEXT, WHITE);
    Title->SetColor(PCI_STEXT, BLACK);
    list->AddToEnd(Title);
    
    //Shift+space => Virtual space
    text = "";
    WORD shspaceTOvspace[] = {feh_, _alef, sad_, _lam_, _heh, vspace, yeh, space, mim_,
      _jim_, _alef, zeh, yeh, space, vav, alef, reh, dal, space, shin_, _vav, dal, '\n',
      beh_, _alef, space, zeh, dal, noon, space, 'e', 'c', 'a', 'p', 'S', space, plus,
      space, 't', 'f', 'i', 'h', 'S'};
    size = sizeof(shspaceTOvspace) / sizeof(WORD);
    for (i = 0; i < size; i++) text += shspaceTOvspace[size - i - 1];
    
    chk = new FaMultiLineCheckBox(L2, 2, text.GetBuffer(), ID_shspaceTOvspace);
    if (ed->shspaceTOvspace) chk->SetSelected(true);
    list->AddToEnd(chk);
    
    //When Typing & PC>CP Converting
    text = "";
    WORD whenTypingPCP[] = {teh_, _alef, yeh_, _peh, space, vav, space,
      teh_, _beh_, _dal, yeh_, _lam, space, reh, alef, yeh_, _alef, noon_, _heh,
      beh_, _heh, kaf_, _lam_, _alef, __sin, peh_, _dal, colon};
    size = sizeof(whenTypingPCP) / sizeof(WORD);
    for (i = 0; i < size; i++) text += whenTypingPCP[size - i - 1];
    
    Title = new PegTextBox(L1, 0, FF_NONE|TJ_RIGHT|TT_COPY, text.GetBuffer());
    Title->SetFont(&FaClassPad);
    Title->SetColor(PCI_NORMAL, BLACK);
    Title->SetColor(PCI_SELECTED, WHITE);
    Title->SetColor(PCI_NTEXT, WHITE);
    Title->SetColor(PCI_STEXT, BLACK);
    list->AddToEnd(Title);
    
    //Arabic kaf => kaf
    text = "";
    WORD akafTOkaf[] = {teh_, _beh_, _dal, yeh_, _lam, space, oquote, akaf, cquote,
      space, beh_, _heh, space, oquote, kaf, cquote};
    size = sizeof(akafTOkaf) / sizeof(WORD);
    for (i = 0; i < size; i++) text += akafTOkaf[size - i - 1];
    
    chk = new FaMultiLineCheckBox(L1, 1, text, ID_akafTOkaf);
    if (ed->akafTOkaf) chk->SetSelected(true);
    list->AddToEnd(chk);
    
    //Yeh with dots below => yeh
    text = "";
    WORD yehdTOyeh[] = {teh_, _beh_, _dal, yeh_, _lam, space, oquote, yehd, cquote,
      space, beh_, _heh, space, oquote, yeh, cquote};
    size = sizeof(yehdTOyeh) / sizeof(WORD);
    for (i = 0; i < size; i++) text += yehdTOyeh[size - i - 1];
    
    chk = new FaMultiLineCheckBox(L1, 1, text, ID_yehdTOyeh);
    if (ed->yehdTOyeh) chk->SetSelected(true);
    list->AddToEnd(chk);
    
    //Latin digit => Farsi digit
    text = "";
    WORD ldigitTOdigit[] = {teh_, _beh_, _dal, yeh_, _lam, space,
      alef, ein_, _dal, alef, dal, lam_, _alef, teh_, _yeh_, _noon, space,
      beh_, _heh, space, feh_, alef, reh, sin_, _yeh};
    size = sizeof(ldigitTOdigit) / sizeof(WORD);
    for (i = 0; i < size; i++) text += ldigitTOdigit[size - i - 1];
    
    chk = new FaMultiLineCheckBox(L1, 1, text, ID_ldigitTOdigit);
    if (ed->ldigitTOdigit) chk->SetSelected(true);
    list->AddToEnd(chk);
    
    //Latin parenthesis => Farsi parenthesis
    text = "";
    WORD lparenTOparen[] = {beh_, _heh, space,
      peh_, _reh, alef, noon_, _teh_, _zeh, heh_, _alef, yeh, space,
      feh_, alef, reh, sin_, _yeh, '\n',
      teh_, _beh_, _dal, yeh_, _lam, space,
      peh_, _reh, alef, noon_, _teh_, _zeh, heh_, _alef, yeh, space,
      lam_, _alef, teh_, _yeh_, _noon, space};
    size = sizeof(lparenTOparen) / sizeof(WORD);
    for (i = 0; i < size; i++) text += lparenTOparen[size - i - 1];
    
    chk = new FaMultiLineCheckBox(L2, 2, text, ID_lparenTOparen);
    if (ed->lparenTOparen) chk->SetSelected(true);
    list->AddToEnd(chk);
    
    //When Typing & Converting
    text = "";
    WORD whenTypingConv[] = {teh_, _alef, yeh_, _peh, space, vav, space,
      teh_, _beh_, _dal, yeh_, _lam, heh_, _alef, colon};
    size = sizeof(whenTypingConv) / sizeof(WORD);
    for (i = 0; i < size; i++) text += whenTypingConv[size - i - 1];
    
    Title = new PegTextBox(L1, 0, FF_NONE|TJ_RIGHT|TT_COPY, text.GetBuffer());
    Title->SetFont(&FaClassPad);
    Title->SetColor(PCI_NORMAL, BLACK);
    Title->SetColor(PCI_SELECTED, WHITE);
    Title->SetColor(PCI_NTEXT, WHITE);
    Title->SetColor(PCI_STEXT, BLACK);
    list->AddToEnd(Title);
    
    //Reverse open/close parenthesis
    text = "";
    WORD CNVparen[] = {jim_, _alef, yeh_, _gaf_, _zeh, yeh_, _noon_, _yeh,
      space, oparen, space, vav, space, cparen};
    size = sizeof(CNVparen) / sizeof(WORD);
    for (i = 0; i < size; i++) text += CNVparen[size - i - 1];
    
    chk = new FaMultiLineCheckBox(L1, 1, text, ID_CNVparen);
    if (ed->CNVparen) chk->SetSelected(true);
    list->AddToEnd(chk);
    
    //Reverse open/close square brakets
    text = "";
    WORD CNVsbrac[] = {jim_, _alef, yeh_, _gaf_, _zeh, yeh_, _noon_, _yeh,
      space, ']', space, vav, space, '['};
    size = sizeof(CNVsbrac) / sizeof(WORD);
    for (i = 0; i < size; i++) text += CNVsbrac[size - i - 1];
    
    chk = new FaMultiLineCheckBox(L1, 1, text, ID_CNVsbrac);
    if (ed->CNVsbrac) chk->SetSelected(true);
    list->AddToEnd(chk);
    
    //Reverse open/close curly brakets
    text = "";
    WORD CNVcbrac[] = {jim_, _alef, yeh_, _gaf_, _zeh, yeh_, _noon_, _yeh,
      space, '}', space, vav, space, '{'};
    size = sizeof(CNVcbrac) / sizeof(WORD);
    for (i = 0; i < size; i++) text += CNVcbrac[size - i - 1];
    
    chk = new FaMultiLineCheckBox(L1, 1, text, ID_CNVcbrac);
    if (ed->CNVcbrac) chk->SetSelected(true);
    list->AddToEnd(chk);
    
    //Reverse open/close quotes
    text = "";
    WORD CNVquote[] = {jim_, _alef, yeh_, _gaf_, _zeh, yeh_, _noon_, _yeh,
      space, oquote, space, vav, space, cquote};
    size = sizeof(CNVquote) / sizeof(WORD);
    for (i = 0; i < size; i++) text += CNVquote[size - i - 1];
    
    chk = new FaMultiLineCheckBox(L1, 1, text, ID_CNVquote);
    if (ed->CNVquote) chk->SetSelected(true);
    list->AddToEnd(chk);
    
    //Reverse greater than/less than
    text = "";
    WORD CNVgtlt[] = {jim_, _alef, yeh_, _gaf_, _zeh, yeh_, _noon_, _yeh,
      space, '>', space, vav, space, '<'};
    size = sizeof(CNVgtlt) / sizeof(WORD);
    for (i = 0; i < size; i++) text += CNVgtlt[size - i - 1];
    
    chk = new FaMultiLineCheckBox(L1, 1, text, ID_CNVgtlt);
    if (ed->CNVgtlt) chk->SetSelected(true);
    list->AddToEnd(chk);
    
    //When CP>PC Converting
    text = "";
    WORD whenTypingCPC[] = {teh_, _beh_, _dal, yeh_, _lam, space,
      kaf_, _lam_, _alef, __sin, peh_, _dal, beh_, _heh,
      reh, alef, yeh_, _alef, noon_, _heh, colon};
    size = sizeof(whenTypingCPC) / sizeof(WORD);
    for (i = 0; i < size; i++) text += whenTypingCPC[size - i - 1];
    
    Title = new PegTextBox(L1, 0, FF_NONE|TJ_RIGHT|TT_COPY, text.GetBuffer());
    Title->SetFont(&FaClassPad);
    Title->SetColor(PCI_NORMAL, BLACK);
    Title->SetColor(PCI_SELECTED, WHITE);
    Title->SetColor(PCI_NTEXT, WHITE);
    Title->SetColor(PCI_STEXT, BLACK);
    list->AddToEnd(Title);
    
    //Kaf => Arabic kaf
    text = "";
    WORD kafTOakaf[] = {teh_, _beh_, _dal, yeh_, _lam, space, oquote, kaf, cquote,
      space, beh_, _heh, space, oquote, akaf, cquote};
    size = sizeof(kafTOakaf) / sizeof(WORD);
    for (i = 0; i < size; i++) text += kafTOakaf[size - i - 1];
    
    chk = new FaMultiLineCheckBox(L1, 1, text, ID_kafTOakaf);
    if (ed->kafTOakaf) chk->SetSelected(true);
    list->AddToEnd(chk);
    
    //Yeh => Yeh with dots below
    text = "";
    WORD yehTOyehd[] = {teh_, _beh_, _dal, yeh_, _lam, space, oquote, yeh, cquote,
      space, beh_, _heh, space, oquote, yehd, cquote};
    size = sizeof(yehTOyehd) / sizeof(WORD);
    for (i = 0; i < size; i++) text += yehTOyehd[size - i - 1];
    
    chk = new FaMultiLineCheckBox(L1, 1, text, ID_yehTOyehd);
    if (ed->yehTOyehd) chk->SetSelected(true);
    list->AddToEnd(chk);
    
    //OK/Cancel
    PegTextButton *btn;
    PegRect rBtn = {22, 184, 78, 197};
    btn = new PegTextButton(rBtn, GetLang(CMN_BUTTON_OK), IDB_OK, AF_ENABLED|TJ_CENTER);
    Add(btn);
    
    rBtn.Shift(60, 0);
    btn = new PegTextButton(rBtn, GetLang(CMN_BUTTON_CANCEL), IDB_CANCEL, AF_ENABLED|TJ_CENTER);
    Add(btn);
}

SIGNED OptsDialog::Message(const PegMessage& Mesg)
{
    switch (Mesg.wType)
    {
        case SIGNAL(IDB_OK, PSF_CLICKED):
            ed->shspaceTOvspace = ((PegCheckBox*)Find(ID_shspaceTOvspace))->IsChecked();
            
            ed->akafTOkaf       = ((PegCheckBox*)Find(ID_akafTOkaf))      ->IsChecked();
            ed->yehdTOyeh       = ((PegCheckBox*)Find(ID_yehdTOyeh))      ->IsChecked();
            ed->ldigitTOdigit   = ((PegCheckBox*)Find(ID_ldigitTOdigit))  ->IsChecked();
            ed->lparenTOparen   = ((PegCheckBox*)Find(ID_lparenTOparen))  ->IsChecked();
            
            ed->CNVparen        = ((PegCheckBox*)Find(ID_CNVparen))       ->IsChecked();
            ed->CNVsbrac        = ((PegCheckBox*)Find(ID_CNVsbrac))       ->IsChecked();
            ed->CNVcbrac        = ((PegCheckBox*)Find(ID_CNVcbrac))       ->IsChecked();
            ed->CNVquote        = ((PegCheckBox*)Find(ID_CNVquote))       ->IsChecked();
            ed->CNVgtlt         = ((PegCheckBox*)Find(ID_CNVgtlt))        ->IsChecked();
            
            ed->kafTOakaf       = ((PegCheckBox*)Find(ID_kafTOakaf))      ->IsChecked();
            ed->yehTOyehd       = ((PegCheckBox*)Find(ID_yehTOyehd))      ->IsChecked();
        default:
            return CPDialog::Message(Mesg);
    }
    return 0;
}

#endif

