#include "FNFrame.h"
#include "EditWindow.h"
#include "FaNegar.h"
#ifndef WIN32
    #include "CPKeyboardManager.h"
    #include "FaKeypad.h"
#endif

void PegAppInitialize(PegPresentationManager *pPresentation)
{
	PegRect Rect;
    Rect.Set(MAINFRAME_LEFT, MAINFRAME_TOP, MAINFRAME_RIGHT, MAINFRAME_BOTTOM);
    
    FNFrame *mf = new FNFrame(Rect);
    #ifndef WIN32
        CPKeyboardManager *keyb = mf->Keypad();
        keyb->ResetNumTabs(5);
        keyb->SetTabString(4, "Fa");
        extern PegFont SmallWidth;
        keyb->SetFont(&SmallWidth);
        PegRect mm = keyb->mReal;
        mm.Shift(2, 2);
        FaKeypad *fKeys = new FaKeypad(keyb->mReal);
        fKeys->RemoveStatus(PSF_ACCEPTS_FOCUS);
        keyb->SetPageClient(4, fKeys);
    #endif
    
    EditWindow *edwin = new EditWindow(mf->FullAppRectangle(), mf);
    mf->SetTopWindow(edwin);
    mf->SetMainWindow(edwin);
    //edwin->Message(PM_STATUS_UPDATE);
    //edwin->Message(PM_ACTIVATE_EDIT);
    
    pPresentation->Add(mf);
}

extern "C" char *ExtensionGetLang(ID_MESSAGE MessageNo)
{
	return "";
}

